#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01300 UI\09001 NameInput\00002 NameInputUI.rb
#----------------------------------------
# Partie 2/3 du mod du Custom Name Input - cette partie permet de supprimer le windowskin générique et de réajuster les coordonnées d'affchage du texte de renommage.

module UI
	class NameInputUI < Window
		# Return the chars the user has inserted
		# @return [Array<String>]
		attr_reader :chars
		# Create a new NameInputUI
		# @param viewport [Viewport]
		# @param max_size [Integer] maximum size of the name
		# @parma chars [Array<String>] chars initialize there
		# @param character [PFM::Pokemon, String, nil] the character to display
		# @param phrase [String] the phrase to display in order to justify the name input
		def initialize(viewport, max_size, chars, character, phrase)
			super(viewport, *window_parameters, skin: 'm_transparent') #Moddé
			@character = character
			@phrase = phrase
			@chars = chars
			@index = 0
			@max_size = max_size
			create_graphics
			@counter = 0
		end

		private

		# Create the character sprite
		def create_character_sprite
			if @character.is_a?(PFM::Pokemon)
				@character_sprite = PokemonIconSprite.new(self, false)
				@character_sprite.data = @character
			elsif @character.is_a?(String)
				@character_sprite = Sprite.new(self)
				@character_sprite.set_bitmap(@character, :character)
				@character_sprite.src_rect.set(nil, nil, @character_sprite.width / 4, @character_sprite.height / 4)
			end
			@character_sprite.set_position(*character_sprite_position)
			@character_sprite.set_origin(@character_sprite.width / 2, @character_sprite.height)
		end

		def character_sprite_position
			return 16, base_y - 4 + 2 * delta_y #moddé - coord X, coord X de l'icone du perso ou du Poké
		end

		# Create the phrase texte
		def create_phrase
			@phrase_text = add_text(base_x, base_y, 0, 16, @phrase)
		end

		# Create the text inputs elements
		def create_inputs
			@inputs = Array.new(@max_size) do |i|
				add_text(base_x + i * delta_x, base_y + delta_y, delta_x, delta_y, NO_CHAR, 1)
			end
		end

		def base_x # coord X du texte supérieur
			40
		end

		def delta_x # espace horizontal entre l'icone et le début du texte supérieur
			8
		end

		def base_y # coord Y du texte supérieur
			6 # Moddé
		end

		def delta_y # espace vertical entre les 2 lignes du texte supérieur
			18
		end

	end
end