#encoding: utf-8
#----------------------------------------
# Mod pour 01400 GamePlay\pokemonsdk\scripts\01300 UI\01100 Input\00700 NameInput.rb
#----------------------------------------
# Partie 3/3 du mod du Custom Name Input - cette partie permet d'avoir un texte personnalisé lors de la phase de renommage, par exemple pour l'adapter à une entrée de mot de passe. Dépendant du CSV 50000.

module GamePlay
	class NameInput < GamePlay::BaseCleanUpdate
		CUSTOM_INPUT_TEXT = 172 #Numéro de variable pour appeler un texte custom. (Laissée à 0 = texte par défaut.) A appeler par event-making juste avant la scène de renommage. Sera remise à 0 automatiquement à la fin de la scène.
		# Hint shown about how to enter name
		# DEFAULT_HINT = [:ext_text, 9000, 162] # "Use your keyboard and press ENTER" - n'est pas affiché chez moi.
		# GUESSED PHRASE when not given
		remove_const :GUESSED_PHRASE
		GUESSED_PHRASE = [:ext_text, 50000, 3] # "How would you name %<name>s?" - Variable CUSTOM_INPUT_TEXT = 0
		HERO_PHRASE = [:ext_text, 50000, 4] # "How would you name your hero?" - Variable CUSTOM_INPUT_TEXT = 1 (+ joueur garçon)
		HEROIN_PHRASE = [:ext_text, 50000, 5] # "How would you name your heroin?"  - Variable CUSTOM_INPUT_TEXT = 1 (+ joueur fille)
		PASSWORD_PHRASE = [:ext_text, 50000, 6] # "Enter the password:"  - Variable CUSTOM_INPUT_TEXT = 2
		# Return the choosen name
		# @return [String]
		attr_reader :return_name
		# Create a new NameInput scene
		# @param default_name [String] the choosen name if no choice
		# @param max_length [Integer] the maximum number of characters in the choosen name
		# @param character [PFM::Pokemon, String, nil] the character to display
		# @param phrase [String, nil] phrase to show in order to display the name

		private

		def guess_phrase #moddé
			name = @character.is_a?(PFM::Pokemon) ? @character.name : @default_name
			if $game_variables[CUSTOM_INPUT_TEXT] == 1 # Texte custom n°1 du nom du héros
				if $game_switches[Yuki::Sw::Gender] == true
					format(get_text(HEROIN_PHRASE), name: name)
				else
					format(get_text(HERO_PHRASE), name: name)
				end
			elsif $game_variables[CUSTOM_INPUT_TEXT] == 2 # Texte custom n°2 du mot de passe - rajouter des elsif juste après si d'autres textes custom. Pensez à les rajouter au CSV.
				format(get_text(PASSWORD_PHRASE), name: name)
			else #Phrase générique
				format(get_text(GUESSED_PHRASE), name: name)
			end
		end


		def confirm_name
			@return_name = @name_input_ui.chars.join if @name_input_ui.chars.any?
			$game_variables[CUSTOM_INPUT_TEXT] = 0 # Ajout du mod - Reset automatique de la variable custom.
			@running = false
		end

		def joypad_update_inputs
			return true # if no joypad connected
		end

		def create_hint_ui #Moddé - Je neutralise, j'affiche cela par image
			#@hint_ui = UI::Window.new(@viewport, 2, 190, 316, 48)
			#@hint_text = @hint_ui.add_text(0, 0, 316 - @hint_ui.window_builder[-2] - @hint_ui.window_builder[4], 16, '')
			#@hint_text.multiline_text = get_text(DEFAULT_HINT)
		end

		def create_joypad_ui
			return nil # Don't forget to pass self to this ui
		end

	end
end
